
function PlayerStandard:clbk_sprint_delay_expire()

	self._sprint_delay = nil
	
	if self._running and not self._end_running_expire_t and not self:_is_reloading() and not self._shooting and not self._camera_unit:base()._melee_item_units then
		self._ext_camera:play_redirect( self:get_animation("start_running") )
	end

end



Hooks:PostHook( PlayerStandard , "_start_action_running" , "MeleeOverhaulExtrasPlayerStandardPostStartActionRunning" , function( self , t )

		if not self._move_dir then
			self._running_wanted = true
			return
		end
		
		if self:on_ladder() or self:_on_zipline() then
			return
		end
		
		if self._shooting and not managers.player.RUN_AND_SHOOT or self:_changing_weapon() or self._use_item_expire_t or self._state_data.in_air or self:_is_throwing_projectile() or self:_is_charging_weapon() then
			self._running_wanted = true
			return
		end
		
		if self._state_data.ducking and not self:_can_stand() then
			self._running_wanted = true
			return
		end
		
		if not self:_can_run_directional() then
			return
		end
		
		if not self:_is_meleeing() and self._camera_unit:base()._melee_item_units then
			self._running_wanted = true
			return
		end
		
		self._running_wanted = false
		
		if managers.player:get_player_rule( "no_run" ) then
			return
		end
		
		if not self._unit:movement():is_above_stamina_threshold() then
			return
		end
		
		if (not self._state_data.shake_player_start_running or not self._ext_camera:shaker():is_playing( self._state_data.shake_player_start_running ) ) and managers.user:get_setting( "use_headbob" ) then
			self._state_data.shake_player_start_running = self._ext_camera:play_shaker( "player_start_running" , 0.75 )
		end
		
		self:set_running( true )
		
		self._end_running_expire_t = nil
		self._start_running_t = t
		
		if not self.RUN_AND_RELOAD then
			self:_interupt_action_reload( t )
		end
		
		self:_interupt_action_steelsight( t )
		self:_interupt_action_ducking( t )
	end )

function PlayerStandard:_end_action_running( t )
	if not self._end_running_expire_t then
		local speed_multiplier = self._equipped_unit:base():exit_run_speed_multiplier()
		
		self._end_running_expire_t = t + 0.4 / speed_multiplier
		if not self:_is_meleeing() then
			if not managers.player.RUN_AND_SHOOT and ( not managers.player.RUN_AND_RELOAD or not self:_is_reloading() ) then
				self._ext_camera:play_redirect( self:get_animation("stop_running") , speed_multiplier )
			end
		end
	end
	
	if self._sprint_delay and not self._camera_unit:base()._melee_item_units then
		self._ext_camera:play_redirect( self:get_animation("idle") )
	end
end

Hooks:PreHook( PlayerStandard , "_start_action_melee" , "MeleeOverhaulExtrasPlayerStandardPreStartActionMelee" , function( self , t , input , instant )

	self._state_data.melee_running_wanted = true and self._running and not self._end_running_expire_t

end )

Hooks:PostHook( PlayerStandard , "_start_action_melee" , "MeleeOverhaulExtrasPlayerStandardPostStartActionMelee" , function( self , t , input , instant )

	if self._state_data.melee_running_wanted then
		self._running_wanted = true
	end
	self._state_data.melee_running_wanted = nil

end )

Hooks:PreHook( PlayerStandard , "_update_melee_timers" , "MeleeOverhaulExtrasPlayerStandardPreUpdateMeleeTimers" , function( self , t , input )

	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	local instant = tweak_data.blackmarket.melee_weapons[ melee_entry ].instant
	
	if not instant and not self._state_data.melee_repeat_expire_t and self._state_data.melee_expire_t and t >= self._state_data.melee_expire_t then
		if self._running and not self._end_running_expire_t then
			if not self:_is_reloading() or not self.RUN_AND_RELOAD then
				if not managers.player.RUN_AND_SHOOT and not self._state_data.meleeing then
					self._ext_camera:play_redirect( self:get_animation("start_running") )
				else
					if not self._state_data.meleeing then
						self._ext_camera:play_redirect( self:get_animation("idle") )
					end
				end
			end
		end
	end
	
	if instant and self._state_data.melee_expire_t and t >= self._state_data.melee_expire_t then
		if self._running and not self._end_running_expire_t then
			if not self:_is_reloading() or not self.RUN_AND_RELOAD then
				if not managers.player.RUN_AND_SHOOT and not self._state_data.meleeing then
					self._ext_camera:play_redirect( self:get_animation("start_running") )
				else
					if not self._state_data.meleeing then
						self._ext_camera:play_redirect( self:get_animation("idle") )
					end
				end
			end
		end
	end

end )

Hooks:PostHook( PlayerStandard , "_interupt_action_melee" , "MeleeOverhaulExtrasPlayerStandardPostInteruptActionMelee" , function( self , t )

		local running = self._running and not self._end_running_expire_t
		
		self:_interupt_action_running( t )
		
		if running then
			self._running_wanted = true
		end
	end )